----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
-- printpak.ads: Paketspezifikation zur Darstellung eines Programms aus der     --
--                  while-Sprache als Syntaxbaum                                --
-- Version 0.2                                                                  --
--  Mar 2008 by Ingo & Nick                                                    --
----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
with comtypes, ada.Text_IO;

use  comtypes, ada.Text_IO;

package printpak is

   -------------------------------------------------------------------------------
   -- typen strichknoten, strichliste
   -- pointerstruktur, deren knoten die werte true oder false annehmen koennen.
   -- spaeter wird von "false" auf drei leerzeichen geschlossen (einruecken)
   --                  "true" auf zwei leerz. und eine vertikale linie geschlossen   
   -------------------------------------------------------------------------------
   type strichknoten;

   type strichliste is access strichknoten;

   type strichknoten is record
      b    : boolean;
      next : strichliste;
   end record;
   
   
   -------------------------------------------------------------------------------
   -- siehe printpak.adb
   -------------------------------------------------------------------------------
   procedure AusgabeN (b : in out GrBaum; j : out strichliste;
                       ebene : in out integer; ausg : File_Type; txt : boolean);


   -------------------------------------------------------------------------------
   -- siehe printpak.adb
   -------------------------------------------------------------------------------
   procedure printGB (gb : GrBaum; ausg : File_Type; txt : boolean);

end printpak;