with Text_IO; use Text_IO;

procedure Aufgabe1 is


   -------------------------------------------------
   -- Vorgaben
   -------------------------------------------------

   type detueber is
     array (Integer range <>,
            Character range <>) of Integer;
   -- ordnet einem Zustand und einem Zeichen
   -- einen Nachfolgezustand zu

   type det_ueber_type (n : Positive) is record
      ueber : detueber (0..n,'!' .. '~');
   end record;
   -- Einschraenkung auf Zustaende 0..n-1 und Fangzustand n
   -- (damit die Uebergangsfunktion total ist);
   -- T ist die Menge der druckbaren ASCII-Zeichen

   type charFktn is
     array (Integer range <>) of Boolean;
   -- Charakteristische Funktion fuer Mengen
   -- ganzer Zahlen

   type charFktn_type (n : Positive) is record
      inh : charFktn (0..n) := (others => False);
   end record;
   -- beschraenkt die Obermenge auf die Zustaende
   -- 0 bis n;
   -- Initialisierung beschreibt die leere Menge

   type DEA_type (n : Positive) is record
      det : det_ueber_type (n);
      F   : charFktn_type (n);
   end record;
   -- beschreibt einen deterministischen endlichen
   -- Automaten mit
   --   Q = {0,1,...,n-1,n} (n ist Fangzustand)
   --   q0 = 0
   --   T = Menge der druckbaren ASCII-Zeichen
   --   delta = det
   --   F = F

   DEA1 : DEA_type (4);

   
   procedure pruefe (DEA : DEA_type; w : String) is
      akt : Integer := 0; -- aktueller Zustand
   begin
      for i in 1..w'Last loop
         akt := DEA.det.ueber (akt, w(i));
      end loop;
      put ("""" &w& """" & " gehoert");
      if not DEA.F.inh(akt) then
         put (" nicht");
      end if;
      put (" zum Sprachschatz");
      new_line(2);
   end pruefe;


   -------------------------------------------------
   -- Ende Vorgaben
   -------------------------------------------------
   
   -------------------------------------------------
   -- Eigene Deklarationen
   -------------------------------------------------
 
   -------------------------------------------------
   -- Nachfolgend sind die Automaten die modelliert werden sollen
   -- festgelegt und werden weiter unten im Detail beschrieben
   -------------------------------------------------
   
   DEAA1 : DEA_type (3); -- Aufgabenzettel A1 
   DEAA2 : DEA_type (4); -- Aufgabenzettel A2
   DEAA3 : DEA_type (4); -- Aufgabenzettel A3
   DEAA4 : DEA_type (4); -- Aufgabenzettel A4
   DEAB1 : DEA_Type (5); -- SyntaxWerkzeugeKomplett.pdf S.113
   DEAB2 : DEA_type (5); -- SyntaxWerkzeugeKomplett.pdf S.114 1.Abb
   DEAB3 : DEA_type (8); -- SyntaxWerkzeugeKomplett.pdf S.114 2.Abb


   -------------------------------------------------
   -- aq
   --
   -- aq vergleicht zwei DEA und gibt True zurck wenn sie 
   -- quivalent sind. 
   -------------------------------------------------

   FUNCTION Aq (DEA1,DEA2 : DEA_Type) RETURN Boolean IS

   
   -- zunchst werden die Tupel erzeugt
     
      TYPE Tupel;   
      TYPE ZTupel IS ACCESS Tupel;      
      TYPE Tupel IS RECORD         
         q:Integer:=0;         
         p:Integer:=0;               
         NextTupel:ZTupel:=NULL;     
      END RECORD;      
      -- Liste der Tupel ende

      
   -------------------------------------------------
      -- Zeichen, ist die Liste der Chars die von dem Automaten verarbeitet werden knnen
   -------------------------------------------------
	  Zeichen:String:="!""#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
      L1,akttupel:ZTupel:=null;


   -------------------------------------------------
   -- NewTupel
   --
   -- Erzeugt einen neuen Listenentrag    -> (q,p,nchstes Element)
   --------------------------------------------------- 
      FUNCTION NewTupel(q,p:Integer; NextTupel:ZTupel) RETURN ZTupel IS
         g:ZTupel;
      BEGIN
         g:=NEW Tupel'(q,p,nexttupel);
         RETURN g;
      end;
    

   -------------------------------------------------
   -- PutList
   --
   -- Die Prozedur Putlist gibt die Liste mit Tupeln auf dem Bildschirm aus
   ---------------------------------------------------   
      
      PROCEDURE Putlist(L:ZTupel)IS
         akttupel:ZTupel;
      BEGIN
      put_line("ZTupel:");   
      akttupel:=L;
      WHILE Akttupel/=NULL LOOP
         Put("(");
         Put(Integer'Image(Akttupel.q));
         Put(",");
         Put(Integer'Image(Akttupel.p));
         Put_Line(")");
         akttupel:=akttupel.Nexttupel;
      END LOOP;
      put_line("Ende ZTupel");   
      END Putlist;
      

   -------------------------------------------------
   -- fangzustand
   --
   -- Die Funktion liefert den Fangzustand des DEA
   --------------------------------------------------- 
      function fangzustand(DEA:DEA_Type) return integer is
      BEGIN
         RETURN DEA.F.Inh'Length-1;
      END Fangzustand;
      

   -------------------------------------------------
   -- Isin
   --
   -- Die Funktion Isin prft ob das Tupel (q,p) in der Liste L1 enthalten ist
   --------------------------------------------------- 
      FUNCTION Isin(q,p:integer) RETURN Boolean IS
      akttupelx:Ztupel;
      BEGIN
         akttupelx:=L1;
         WHILE Akttupelx/=NULL LOOP
            IF (Akttupelx.Q=Q) AND (Akttupelx.P=P) THEN
               RETURN True;
            END IF;
               akttupelx:=akttupelx.nexttupel;        
         end LOOP;
      return false;         
      END Isin;
      
   -------------------------------------------------
   -- Listtupel
   --
   -- Erzeugt die Liste mit Tupel von (Zustand1,Zustand2) und alle die man von dort erreicht
   ---------------------------------------------------    
      PROCEDURE Listtupel(Zustand1,Zustand2:Integer) is
      z1,z2:integer;
      BEGIN
         FOR Ic IN Zeichen'First..Zeichen'Last-1  LOOP
            Z1:=DEA1.Det.Ueber (Zustand1, Zeichen(Ic));
            Z2:=DEA2.Det.Ueber (Zustand2, Zeichen(Ic));
            if ( z1/=fangzustand(DEA1) ) or (z2/=fangzustand(DEA2) ) then 
               IF NOT Isin(Z1,Z2) THEN
                  L1:=NewTupel(Z1,Z2,L1);              
                  Listtupel(Z1,Z2);               
               END IF;               
            END IF; 
         END LOOP;      
      END Listtupel;
      
       
   BEGIN -- Begin AQ
   -- Liste der Tupel Anlegen
      Listtupel(0,0);
  

   -- Prfe auf Eintrge in der Liste:
   -- Wenn q Fangzustand dann muss p Fangzustand und andersrum
   -- Wenn q KEIN Fangzustand dann auch p KEIN Fangzustand und andersrum
   
   akttupel:=L1;
   WHILE Akttupel/=NULL LOOP
         IF ((Fangzustand(DEA1)=akttupel.Q) /=  (Fangzustand(DEA2)=akttupel.P )) or
            (DEA1.F.inh(akttupel.Q))/=(DEA2.F.inh(akttupel.P))then      
            RETURN False; -- Fehler gefunden
          end if;  
 
     akttupel:=akttupel.nexttupel; -- nchstes Element        
   end LOOP;

         RETURN True;--Gib True zurck wenn kein Fehler gefunden wird   
   END Aq;
   
      

BEGIN
   -------------------------------------------------
   -- Die oben aufgefhrten DEA im Detail modelliert
   -------------------------------------------------    

   DEA1.det.ueber :=
     (0 => ('a' => 1, 'b' => 2, others => 4),
      1 => ('a' => 0, 'b' => 3, others => 4),
      2 => ('a' => 3, 'b' => 0, others => 4),
      3 => ('a' => 2, 'b' => 1, others => 4),
      4 => (others => 4));

   DEA1.F.Inh := (3 => True, OTHERS => False);
   
   
   DEAB1.det.ueber :=
     (0 => ('a' => 1, others => 5),
      1 => ('a' => 2, others => 5),
      2 => ('a' => 3, 'b' => 2, others => 5),
      3 => ('b' => 4, others => 5),
      4 => ('a' => 0, others => 5),
	  5 => (others => 5));
   DEAB1.F.Inh := (2 => True, 0 => True, OTHERS => False);
   
  
   DEAA1.det.ueber :=
     (0 => ('a' => 1, 'b' => 2, others => 3),
      1 => ('a' => 2, 'b' => 1, others => 3),
      2 => (others => 3),
      3 => (others => 3));
      

   DEAA1.F.inh := (2 => True, others => False);
   

   DEAA2.det.ueber :=
     (0 => ('a' => 1, 'b' => 3, others => 4),
      1 => ('a' => 3, 'b' => 2, others => 4),
      2 => ('a' => 3, 'b' => 2, others => 4),
      3 => (others => 4),
      4 => (others => 4));

   DEAA2.F.inh := (3 => True, others => False);
   

  DEAA3.det.ueber :=
     (0 => ('a' => 2, 'b' => 3, others => 4),
      1 => ('a' => 3, 'b' => 2, others => 4),
      2 => ('a' => 3, 'b' => 1, others => 4),
      3 => (others => 4),
      4 => (others => 4));

   DEAA3.F.inh := (3 => True, others => False);
   

   DEAA4.det.ueber :=
     (0 => ('a' => 1, 'b' => 3, others => 4),
      1 => ('a' => 2, 'b' => 0, others => 4),
      2 => ('a' => 3, 'b' => 2, others => 4),
      3 => (others => 4),
      4 => (others => 4));

   DEAA4.F.inh := (3 => True, others => False);


   DEAB1.det.ueber :=
     (0 => ('a' => 1, others => 5),
      1 => ('a' => 2, others => 5),
      2 => ('a' => 3, 'b' => 2, others => 5),
      3 => ('b' => 4, others => 5),
      4 => ('a' => 0, others => 5),
	5 => (others => 5));

   DEAB1.F.inh := (2 => True, 0 => True, others => False);
   

   DEAB2.det.ueber :=
     (0 => ('.' => 1, '-' => 1, others => 5),
      1 => ('.' => 2, '-' => 2, others => 5),
      2 => ('.' => 3, '-' => 3, others => 5),
      3 => ('.' => 4, '-' => 4, others => 5),
      4 => (others => 5),
	5 => (others => 5));

   DEAB2.F.inh := (1 => True, 2 => True, 3 => True, 4 => True, others => False);
   

   DEAB3.det.ueber :=
     (0 => ('V' => 1, 'I' => 2, 'X' => 6, others => 8),
      1 => ('I' => 7, others => 8),
      2 => ('I' => 3, 'V' => 5, 'X' => 6, others => 8),
      3 => ('I' => 4, others => 8),
	4 => (others => 8),
      5 => (others => 8),
      6 => (others => 8),
      7 => ('I' => 3, others => 8),
	8 => (others => 8));

   DEAB3.F.inh := (1 => True, 2 => True, 3 => True, 4 => True, 5 => True, 6 => True, 7 => True, others => False);

   -------------------------------------------------
   -- Ende der DEA
   ---------------------------------------------------  
   



   -------------------------------------------------
   -- vergleichen der DEA A1-A4
   ---------------------------------------------------  

-- A1-A2
   IF Aq(DEAA1,DEAA2) THEN Put_Line("Die DEA 1 und 2 sind gleich");
      ELSE Put_Line("Die DEA 1 und 2 sind nicht gleich");
         end if;
-- A1-A3
   IF Aq(DEAA1,DEAA3) THEN Put_Line("Die DEA 1 und 3 sind gleich");
      ELSE Put_Line("Die DEA 1 und 3 sind nicht gleich");
         end if;
-- A1-A4
   IF Aq(DEAA1,DEAA4) THEN Put_Line("Die DEA 1 und 4 sind gleich");
      ELSE Put_Line("Die DEA 1 und 4 sind nicht gleich");
         end if;
-- A2-A3
   IF Aq(DEAA2,DEAA3) THEN Put_Line("Die DEA 2 und 3 sind gleich");
      ELSE Put_Line("Die DEA 2 und 3 sind nicht gleich");
         end if;
-- A2-A4
   IF Aq(DEAA2,DEAA4) THEN Put_Line("Die DEA 2 und 3 sind gleich");
      ELSE Put_Line("Die DEA 2 und 4 sind nicht gleich");
         end if;
-- A3-A4
   IF Aq(DEAA3,DEAA4) THEN Put_Line("Die DEA 3 und 4 sind gleich");
      ELSE Put_Line("Die DEA 3 und 4 sind nicht gleich");
         end if;

   -------------------------------------------------
   -- Ausgabe-Fenster:
   --  Die DEA 1 und 2 sind gleich
   --  Die DEA 1 und 3 sind gleich
   --  Die DEA 1 und 4 sind nicht gleich
   --  Die DEA 2 und 3 sind gleich
   --  Die DEA 2 und 4 sind nicht gleich
   --  Die DEA 3 und 4 sind nicht gleich
   ---------------------------------------------------  
		 
		 
   
   -------------------------------------------------
   -- Zum Prfen eines String fr ein DEA
      --  pruefe (DEA1, "aba");
   
   --Beispieleingaben fr DEAB1 - DEAB3"
   
  pruefe (DEAB1, "aa");
     --Ausgabe: "aa" gehrt zum Sprachschatz
  pruefe (DEAB1, "aaaba");
     --Ausgabe: "aaaba" gehrt zum Sprachschatz
  pruefe (DEAB1, "ab");
     --Ausgabe: "ab" gehrt nicht zum Sprachschatz
  pruefe (DEAB1, "aaba");
     --Ausgabe: "aaba" gehrt nicht zum Sprachschatz
   
  pruefe (DEAB2, ".....");
     --Ausgabe: "....." gehrt nicht zum Sprachschatz
  pruefe (DEAB2, "----");
     --Ausgabe: "----" gehrt zum Sprachschatz
  pruefe (DEAB2, "-.--");
     --Ausgabe: "-.--" gehrt zum Sprachschatz
  pruefe (DEAB2, "------");
     --Ausgabe: "------" gehrt nicht zum Sprachschatz
	 
  pruefe (DEAB3, "V");
     --Ausgabe: "V" gehrt zum Sprachschatz
  pruefe (DEAB3, "VIII");
     --Ausgabe: "VIII" gehrt zum Sprachschatz
  pruefe (DEAB3, "VIIII");
     --Ausgabe: "VIIII" gehrt nicht zum Sprachschatz
  pruefe (DEAB3, "VXI");
     --Ausgabe: "VXI" gehrt nicht zum Sprachschatz
   ---------------------------------------------------  

end Aufgabe1;
