-- Test-Grammatik1

-- In diesem Beispiel wird eine fiktive Grammatik mit ihren Regeln
-- herangezogen. In der Typdefinition "Grammatiksymbole" werden zuerst
-- die Nicht-Terminale und Terminale festgelegt. Danach werden die
-- notwendigen Pakete geladen, instanziiert - hier nur das
-- "Relationenpaket" - und eingebunden. Die Pakete "Gg", "Paar" und
-- "Menge" werden vom "Relationenpaket" geladen und ber die "use"
-- Aufrufe hierher weitergegeben. Nun werden alle mglichen
-- "rechten Regelseiten" in "rechteSeiten" aufgelistet.
-- Mit jedem Aufruf "neueAlternativeHinzu" wird dem ersten Parameter,
-- dem Nicht-Terminal, entweder keine - Zuweisung aus dem leeren
-- Array 1..0 - oder eine rechte Seite aus dem Zeichenarray
-- "rechte Seiten" zugewiesen. Durch mehrere Aufrufe mit demselben
-- Nicht-Terminal knnen selbstverstndlich mehrere unterschiedliche
-- Regeln erstellt werden. Hierdurch werden die Regeln der Grammatik
-- definiert. Zuletzt folgt die Ausgabe der kompletten Grammatik 
-- mit allen Symbolen, Regeln, einer Aussage ber ihre Einfachheit,
-- sowie - falls vorhanden - der Epsilonsymbole, und den Anfang-,
-- Neben-, Ende, First- und Followmengen.

with Text_IO; use Text_IO;
with Relationenpaket;

procedure TestGrammatik1 is 


   type Grammatiksymbole is (S, A, B, C, E, cc, bb, g, '#');

   package Klammpak is new Relationenpaket(Grammatiksymbole,5);
   use Klammpak;
   use Gg;
                         
   -- in "Relationenpaket" mit "Gg" instanz. Paket "GrammatikGenerator2"
   
   use Paar;
                       
   -- in "Relationenpaket" mit "Paar" instanz. Paket "ToAdi"
   
   use Menge; 
                     
   -- in "Relationenpaket" mit "Menge" instanz. Paket "Mengen"

   Rechteseiten : Zeichenarray (1 .. 12) :=
      (A, C, B, E, C, b, cc, g, bb, bb, bb, E);  

begin

   neueAlternativeHinzu (S, rechteSeiten(1..2));         -- S -> A C
   neueAlternativeHinzu (S, rechteSeiten(3..4));         -- S -> B E
   neueAlternativeHinzu (S, rechteSeiten(5..7));         -- S -> C B cc 

   neueAlternativeHinzu (A, rechteSeiten(8..8));         -- A -> g

   neueAlternativeHinzu (B, rechteSeiten(1..0));         -- B -> Epsilon
   neueAlternativeHinzu (B, rechteSeiten(9..9));         -- B -> bb

   neueAlternativeHinzu (C, rechteSeiten(10..11));       -- C -> bb bb
   neueAlternativeHinzu (C, rechteSeiten(12..12));       -- C -> E

   neueAlternativeHinzu (E, rechteSeiten(1..0));         -- E -> Epsilon



   Druckegrammatik;
   new_line(2);

   put("Die Test-Grammatik ist ");
   if not istGrammatikEinfach
         then
      put("nicht ");
   end if;
   put("einfach.");
   new_line(2);


   druckeEps(Epszaehler);
   new_line(2);
   
   put_line("Anfang:");
   druckeMenge(Anfang);
   new_line(2);
   
   put_line("Neben:");
   druckeMenge(Neben);
   new_line(2);
   
   put_line("Ende:");
   druckeMenge(Ende);
   new_Line(2);
   
   put_line("First:");
   druckeMenge (first);
   new_Line(2);
   
   put_line("Follow:");
   druckeMenge(follow);
   

-- Testaufrufe:
---------------

-- druckeEps(Epszaehler): { S B C E } sind Epsilon-Symbole.

-- Anfang:                
--                     M:={(G,G);(BB,BB);(CC,CC);(C,E);(C,BB);(A,G);
--                         (S,CC);(S,B);(S,C);(S,E);(S,B);(S,A);}

-- Neben:              M:={(BB,BB);(B,CC);(C,CC);(C,B);(B,E);(A,C);}

-- Ende:                  
--                     M:={(G,G);(BB,BB);(CC,CC);(C,E);(C,BB);(A,G);
--                         (S,CC);(S,C);(S,E);(S,B);(S,C);(S,A);}

-- First:              M:={(C,BB);(A,G);(S,G);(S,BB);(S,CC);}

-- Follow:             M:={(E,CC);(C,CC);(B,CC);(A,BB);}


end TestGrammatik1;
