-- Instanziierungsprogramm zum Test des Matrix Package auf
-- Integer-Zahlen
-- Der Wertebereich wurde hier auf 1 bis 6 festgelegt
-- Die Programmausgabe ist am Ende dieser Datei abgebildet


with toadi;

-- Instanziierung der generischen Matrix.adb auf Integer
   procedure InstantiierungInt is
      subtype SmalInt is Integer range 1..6;
   package AdiTest is new toadi(SmalInt);
   use AdiTest;
   use Mat;

-- Testmatrizen zur Darstellung der Arbeitsweise der Funktionen
-- Matrix Mat1 auf Hauptdiagonalen belegt   
   Mat1: Z_Matrix:= 
        ((true,false,false,false,false,false),
         (false,true,false,false,false,false),
         (false,false,true,false,false,false),
         (false,false,false,true,false,false),
         (false,false,false,false,true,false),
         (false,false,false,false,false,true));
         
-- Mat2 wahllos belgegt
   Mat2: Z_Matrix:= 
        ((false,false,false,false,true,false),
         (false,false,true,true,false,false),
         (true,false,false,false,false,false),
         (false,false,false,false,true,false),
         (false,true,false,true,false,true),
         (true,false,false,false,false,false));
         
-- Mat3 nur mit 2 "TRUE" belegt hauptschlich zum Test der Funktion    
-- ReflexTransHuelle
   Mat3: Z_Matrix:= 
        ((false,true, false,false,false,false),
         (false,false,true,false,false,false),
         (false,false,false,false,false,false),
         (false,false,false,false,false,false),
         (false,false,false,false,false,false),
         (false, false,false,false,false,false));
         
   Mat4: Z_Matrix:= 
        ((false,false, false,false,true,false),
         (false,false,true,true,false,false),
         (true,false,false,false,false,false),
         (false,false,false,false,true,false),
         (false,true,false,true,false,true),
         (true,false,false,false,false,false));
         
-- Mat5 nur mit "FALSE" belegt 
-- Mat6 nur mit "TRUE" belegt    
-- Test des Spezialfalles
   Mat5: Z_Matrix:= (others=>(others=>false));
   Mat6: Z_Matrix:= (others=>(others=>true)) ;  
   
begin
      
-- an dieser Stelle werden die Funktionen aus dem Matrix Package
-- aufgerufen um zu testen ob sie funktionieren
-- das Ergebnis dieses Aufrufs folgt am Ende
-- zuerst gibt das Programm die drei Testmatrizen aus
-- anschlieend erfolgt die Ausgabe der einzelenen Funktionen
-- Die Beschreibung der Funktionen folgt in Matrix.adb
  
   Drucke(Mat1,"Matrix 1");
      
   Drucke(Mat2,"Matrix 2");
   
   Drucke(Mat3,"Matrix 3");
   
   Drucke(Mat4,"Matrix 4");
   
   Drucke(Mat5,"Matrix 5");
   
   Drucke(Mat6,"Matrix 6");
   
   Drucke(Produkt(Mat1,Mat2),"Matrix Produkt - Mat1 * Mat2");
     
   Drucke(Summe(Mat1,Mat2),"Matrix Summe - Mat1 + Mat2");
      
   Drucke(Transponiere(Mat2),"Matrix transpon");
    
   Drucke(Transhuelle(Mat3),"Matrix TransHuelle");

   Drucke(ReflexTransHuelle(Mat3),"Matrix ReflexTransHuelle"); 
   
------------------------------ Spezialflle ------------------------
   
   Drucke(Produkt(Mat5,Mat2),
      "Matrix Produkt - Spezialfall Mat2 * Mat5");
     
   Drucke(Summe(Mat5,Mat2),"Matrix Summe - Spezialfall Mat2 + Mat5");
      
   Drucke(Transponiere(Mat5),"Matrix transpon - Spezialfall Mat5");
    
   Drucke(Transhuelle(Mat5),"Matrix TransHuelle - Spezialfall Mat5");

   Drucke(Reflextranshuelle(Mat5),
      "Matrix ReflexTransHuelle - Spezialfall Mat5"); 
   
   Drucke(Produkt(Mat6,Mat2),
      "Matrix Produkt - Spezialfall Mat2 * Mat6");
     
   Drucke(Summe(Mat6,Mat2),"Matrix Summe - Spezialfall Mat2 + Mat6");
      
   Drucke(Transponiere(Mat6),"Matrix transpon - Spezialfall Mat6");
    
   Drucke(Transhuelle(Mat6),"Matrix TransHuelle - Spezialfall Mat6");

   Drucke(Reflextranshuelle(Mat6),
      "Matrix ReflexTransHuelle - Spezialfall Mat6"); 

   Druckematrix(Erzeugeadimatrix (Erzeugemenge(Mat4)),
      "Test Matrix -> Menge -> Matrix von Matrix 4");
   
   DruckeMenge(ErzeugeMenge(Mat4));
   
   Drucke(transition(Mat3,Mat4),
      "Transition von Matrix 3 und Matrix 4");
   
end InstantiierungInt;
   

-- Darstellung der Programmausgabe


--Matrix 1

--      1  2  3  4  5  6

-- 1 :  1  0  0  0  0  0
-- 2 :  0  1  0  0  0  0
-- 3 :  0  0  1  0  0  0
-- 4 :  0  0  0  1  0  0
-- 5 :  0  0  0  0  1  0
-- 6 :  0  0  0  0  0  1



--Matrix 2

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  1  0
-- 2 :  0  0  1  1  0  0
-- 3 :  1  0  0  0  0  0
-- 4 :  0  0  0  0  1  0
-- 5 :  0  1  0  1  0  1
-- 6 :  1  0  0  0  0  0



--Matrix 3

--      1  2  3  4  5  6

-- 1 :  0  1  0  0  0  0
-- 2 :  0  0  1  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix 4

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  1  0
-- 2 :  0  0  1  1  0  0
-- 3 :  1  0  0  0  0  0
-- 4 :  0  0  0  0  1  0
-- 5 :  0  1  0  1  0  1
-- 6 :  1  0  0  0  0  0



--Matrix 5

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  0  0
-- 2 :  0  0  0  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix 6

--      1  2  3  4  5  6

-- 1 :  1  1  1  1  1  1
-- 2 :  1  1  1  1  1  1
-- 3 :  1  1  1  1  1  1
-- 4 :  1  1  1  1  1  1
-- 5 :  1  1  1  1  1  1
-- 6 :  1  1  1  1  1  1



--Matrix Produkt - Mat1 * Mat2

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  1  0
-- 2 :  0  0  1  1  0  0
-- 3 :  1  0  0  0  0  0
-- 4 :  0  0  0  0  1  0
-- 5 :  0  1  0  1  0  1
-- 6 :  1  0  0  0  0  0



--Matrix Summe - Mat1 + Mat2

--      1  2  3  4  5  6

-- 1 :  1  0  0  0  1  0
-- 2 :  0  1  1  1  0  0
-- 3 :  1  0  1  0  0  0
-- 4 :  0  0  0  1  1  0
-- 5 :  0  1  0  1  1  1
-- 6 :  1  0  0  0  0  1



--Matrix transpon

--      1  2  3  4  5  6

-- 1 :  0  0  1  0  0  1
-- 2 :  0  0  0  0  1  0
-- 3 :  0  1  0  0  0  0
-- 4 :  0  1  0  0  1  0
-- 5 :  1  0  0  1  0  0
-- 6 :  0  0  0  0  1  0



--Matrix TransHuelle

--      1  2  3  4  5  6

-- 1 :  0  1  1  0  0  0
-- 2 :  0  0  1  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix ReflexTransHuelle

--      1  2  3  4  5  6

-- 1 :  1  1  1  0  0  0
-- 2 :  0  1  1  0  0  0
-- 3 :  0  0  1  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix Produkt - Spezialfall Mat2 * Mat5

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  0  0
-- 2 :  0  0  0  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix Summe - Spezialfall Mat2 + Mat5

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  1  0
-- 2 :  0  0  1  1  0  0
-- 3 :  1  0  0  0  0  0
-- 4 :  0  0  0  0  1  0
-- 5 :  0  1  0  1  0  1
-- 6 :  1  0  0  0  0  0



--Matrix transpon - Spezialfall Mat5

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  0  0
-- 2 :  0  0  0  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix TransHuelle - Spezialfall Mat5

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  0  0
-- 2 :  0  0  0  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix ReflexTransHuelle - Spezialfall Mat5

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  0  0
-- 2 :  0  0  0  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0



--Matrix Produkt - Spezialfall Mat2 * Mat6

--      1  2  3  4  5  6

-- 1 :  1  1  1  1  1  1
-- 2 :  1  1  1  1  1  1
-- 3 :  1  1  1  1  1  1
-- 4 :  1  1  1  1  1  1
-- 5 :  1  1  1  1  1  1
-- 6 :  1  1  1  1  1  1



--Matrix Summe - Spezialfall Mat2 + Mat6

--      1  2  3  4  5  6

-- 1 :  1  1  1  1  1  1
-- 2 :  1  1  1  1  1  1
-- 3 :  1  1  1  1  1  1
-- 4 :  1  1  1  1  1  1
-- 5 :  1  1  1  1  1  1
-- 6 :  1  1  1  1  1  1



--Matrix transpon - Spezialfall Mat6

--      1  2  3  4  5  6

-- 1 :  1  1  1  1  1  1
-- 2 :  1  1  1  1  1  1
-- 3 :  1  1  1  1  1  1
-- 4 :  1  1  1  1  1  1
-- 5 :  1  1  1  1  1  1
-- 6 :  1  1  1  1  1  1



--Matrix TransHuelle - Spezialfall Mat6

--      1  2  3  4  5  6

-- 1 :  1  1  1  1  1  1
-- 2 :  1  1  1  1  1  1
-- 3 :  1  1  1  1  1  1
-- 4 :  1  1  1  1  1  1
-- 5 :  1  1  1  1  1  1
-- 6 :  1  1  1  1  1  1



--Matrix ReflexTransHuelle - Spezialfall Mat6

--      1  2  3  4  5  6

-- 1 :  1  1  1  1  1  1
-- 2 :  1  1  1  1  1  1
-- 3 :  1  1  1  1  1  1
-- 4 :  1  1  1  1  1  1
-- 5 :  1  1  1  1  1  1
-- 6 :  1  1  1  1  1  1



--Test Matrix -> Menge -> Matrix von Matrix 4

--      1  2  3  4  5  6

-- 1 :  0  0  0  0  1  0
-- 2 :  0  0  1  1  0  0
-- 3 :  1  0  0  0  0  0
-- 4 :  0  0  0  0  1  0
-- 5 :  0  1  0  1  0  1
-- 6 :  1  0  0  0  0  0

--M:={( 1, 5);( 2, 3);( 2, 4);( 3, 1);( 4, 5);
--    ( 5, 2);( 5, 4);( 5, 6);( 6, 1);}

--Transition von Matrix 3 und Matrix 4

--      1  2  3  4  5  6

-- 1 :  0  0  1  1  0  0
-- 2 :  1  0  0  0  0  0
-- 3 :  0  0  0  0  0  0
-- 4 :  0  0  0  0  0  0
-- 5 :  0  0  0  0  0  0
-- 6 :  0  0  0  0  0  0 