-- Instanziierungsprogramm zum Test des Matrix Package auf
-- Buchstaben (Character)
-- Der Wertebereich wurde hier von A bis F festgelegt
-- Die Programmausgabe ist am Ende dieser Datei abgebildet

with matrix;

-- Instanziierung der generischen Matrix.adb auf Character
   procedure InstanziierungChar is
      subtype SmalChar is Character range 'A'..'F';
   package IntMatrix is new Matrix(SmalChar);
   use IntMatrix;

-- Testmatrizen zur Darstellung der Arbeitsweise der Funktionen
      
-- Matrix Mat1 auf Hauptdiagonalen belegt   
   Mat1: Z_Matrix:= 
        ((true,false,false,false,false,false),
         (false,true,false,false,false,false),
         (false,false,true,false,false,false),
         (false,false,false,true,false,false),
         (false,false,false,false,true,false),
         (false,false,false,false,false,true));
         
-- Mat2 wahllos belegt
   Mat2: Z_Matrix:= 
        ((false,false,false,false,true,false),
         (false,false,true,true,false,false),
         (true,false,false,false,false,false),
         (false,false,false,false,true,false),
         (false,true,false,true,false,true),
         (true,false,false,false,false,false));
         
-- Mat3 nur mit 2 "TRUE" belegt, hauptschlich zum Test der Funktion    
-- ReflexTransHuelle
   Mat3: Z_Matrix:= 
        ((false,true,false,false,false,false),
         (false,false,true,false,false,false),
         (false,false,false,false,false,false),
         (false,false,false,false,false,false),
         (false,false,false,false,false,false),
         (false,false,false,false,false,false));
         
-- Mat4 nur mit "FALSE" belegt 
-- Mat5 nur mit "TRUE" belegt    
-- Test des Spezialfalles
   Mat4: Z_Matrix:= (others=>(others=>false));
   Mat5: Z_Matrix:= (others=>(others=>true)) ;  
   
begin
      
-- An dieser Stelle werden die Funktionen aus dem Matrix Package
-- aufgerufen um zu testen ob sie funktionieren.
-- Das Ergebnis dieses Aufrufs folgt am Ende.
-- Zuerst gibt das Programm die drei Testmatrizen aus
-- anschlieend erfolgt die Ausgabe der einzelnen Funktionen.
-- Die Beschreibung der Funktionen folgt in Matrix.adb
   
   Drucke(Mat1,"Matrix 1");
      
   Drucke(Mat2,"Matrix 2");
   
   Drucke(Mat3,"Matrix 3");
   
   Drucke(Mat4,"Matrix 4");
   
   Drucke(Mat5,"Matrix 5");
   
   Drucke(Produkt(Mat1,Mat2),"Matrix Produkt");
     
   Drucke(Summe(Mat1,Mat2),"Matrix Summe");
      
   Drucke(Transponiere(Mat2),"Matrix transpon");
    
   Drucke(Transhuelle(Mat3),"Matrix TransHuelle");

   Drucke(ReflexTransHuelle(Mat3),"Matrix ReflexTransHuelle"); 
   
------------------------------ Spezialflle ------------------------
   
   Drucke(Produkt(Mat4,Mat2),"Matrix Produkt - Spezialfall Mat4");
     
   Drucke(Summe(Mat4,Mat2),"Matrix Summe- Spezialfall Mat4");
      
   Drucke(Transponiere(Mat4),"Matrix transpon- Spezialfall Mat4");
    
   Drucke(Transhuelle(Mat4),"Matrix TransHuelle- Spezialfall Mat4");

   Drucke(Reflextranshuelle(Mat4),
      "Matrix ReflexTransHuelle- Spezialfall Mat4"); 
   
   Drucke(Produkt(Mat5,Mat2),"Matrix Produkt- Spezialfall Mat5");
     
   Drucke(Summe(Mat5,Mat2),"Matrix Summe- Spezialfall Mat5");
     
   Drucke(Transponiere(Mat5),"Matrix transpon- Spezialfall Mat5");
    
   Drucke(Transhuelle(Mat5),"Matrix TransHuelle- Spezialfall Mat5");

   Drucke(Reflextranshuelle(Mat5),
      "Matrix ReflexTransHuelle- Spezialfall Mat5"); 

end InstanziierungChar;


-- Darstellung der Programmausgabe

--Matrix 1

--      'A''B''C''D''E''F'

--'A' :  1  0  0  0  0  0
--'B' :  0  1  0  0  0  0
--'C' :  0  0  1  0  0  0
--'D' :  0  0  0  1  0  0
--'E' :  0  0  0  0  1  0
--'F' :  0  0  0  0  0  1



--Matrix 2

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  1  0
--'B' :  0  0  1  1  0  0
--'C' :  1  0  0  0  0  0
--'D' :  0  0  0  0  1  0
--'E' :  0  1  0  1  0  1
--'F' :  1  0  0  0  0  0



--Matrix 3

--      'A''B''C''D''E''F'

--'A' :  0  1  0  0  0  0
--'B' :  0  0  1  0  0  0
--'C' :  0  0  0  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



--Matrix 4

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  0  0
--'B' :  0  0  0  0  0  0
--'C' :  0  0  0  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



--Matrix 5

--      'A''B''C''D''E''F'

--'A' :  1  1  1  1  1  1
--'B' :  1  1  1  1  1  1
--'C' :  1  1  1  1  1  1
--'D' :  1  1  1  1  1  1
--'E' :  1  1  1  1  1  1
--'F' :  1  1  1  1  1  1


-- Matrix Produkt stellt das Produkt der Matrizen Mat1 und Mat2 dar

--Matrix Produkt

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  1  0
--'B' :  0  0  1  1  0  0
--'C' :  1  0  0  0  0  0
--'D' :  0  0  0  0  1  0
--'E' :  0  1  0  1  0  1
--'F' :  1  0  0  0  0  0


-- Matrix Summe stellt die Summe der Matrizen Mat1 und Mat2 dar

--Matrix Summe

--      'A''B''C''D''E''F'

--'A' :  1  0  0  0  1  0
--'B' :  0  1  1  1  0  0
--'C' :  1  0  1  0  0  0
--'D' :  0  0  0  1  1  0
--'E' :  0  1  0  1  1  1
--'F' :  1  0  0  0  0  1



-- Matrix transpon stellt die Transposition der Matrix Mat2 dar

--Matrix transpon

--      'A''B''C''D''E''F'

--'A' :  0  0  1  0  0  1
--'B' :  0  0  0  0  1  0
--'C' :  0  1  0  0  0  0
--'D' :  0  1  0  0  1  0
--'E' :  1  0  0  1  0  0
--'F' :  0  0  0  0  1  0



-- Matrix TransHuelle stellt die Transitive Huelle der Matrix Mat3 dar

--Matrix TransHuelle

--      'A''B''C''D''E''F'

--'A' :  0  1  1  0  0  0
--'B' :  0  0  1  0  0  0
--'C' :  0  0  0  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



-- Matrix ReflexTransHuelle stellt die reflexiv-transitive Huelle 
-- der Matrix Mat3 dar

--Matrix ReflexTransHuelle

--      'A''B''C''D''E''F'

--'A' :  1  1  1  0  0  0
--'B' :  0  1  1  0  0  0
--'C' :  0  0  1  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



-- Im Folgenden werden alle Funktionen noch einmal mit
-- Spezialfllen aufgerufen

--Matrix Produkt - Spezialfall Mat4

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  0  0
--'B' :  0  0  0  0  0  0
--'C' :  0  0  0  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



--Matrix Summe- Spezialfall Mat4

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  1  0
--'B' :  0  0  1  1  0  0
--'C' :  1  0  0  0  0  0
--'D' :  0  0  0  0  1  0
--'E' :  0  1  0  1  0  1
--'F' :  1  0  0  0  0  0



--Matrix transpon- Spezialfall Mat4

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  0  0
--'B' :  0  0  0  0  0  0
--'C' :  0  0  0  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



--Matrix TransHuelle- Spezialfall Mat4

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  0  0
--'B' :  0  0  0  0  0  0
--'C' :  0  0  0  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



--Matrix ReflexTransHuelle- Spezialfall Mat4

--      'A''B''C''D''E''F'

--'A' :  0  0  0  0  0  0
--'B' :  0  0  0  0  0  0
--'C' :  0  0  0  0  0  0
--'D' :  0  0  0  0  0  0
--'E' :  0  0  0  0  0  0
--'F' :  0  0  0  0  0  0



--Matrix Produkt- Spezialfall Mat5

--      'A''B''C''D''E''F'

--'A' :  1  1  1  1  1  1
--'B' :  1  1  1  1  1  1
--'C' :  1  1  1  1  1  1
--'D' :  1  1  1  1  1  1
--'E' :  1  1  1  1  1  1
--'F' :  1  1  1  1  1  1



--Matrix Summe- Spezialfall Mat5

--      'A''B''C''D''E''F'

--'A' :  1  1  1  1  1  1
--'B' :  1  1  1  1  1  1
--'C' :  1  1  1  1  1  1
--'D' :  1  1  1  1  1  1
--'E' :  1  1  1  1  1  1
--'F' :  1  1  1  1  1  1



--Matrix transpon- Spezialfall Mat5

--      'A''B''C''D''E''F'

--'A' :  1  1  1  1  1  1
--'B' :  1  1  1  1  1  1
--'C' :  1  1  1  1  1  1
--'D' :  1  1  1  1  1  1
--'E' :  1  1  1  1  1  1
--'F' :  1  1  1  1  1  1



--Matrix TransHuelle- Spezialfall Mat5

--      'A''B''C''D''E''F'

--'A' :  1  1  1  1  1  1
--'B' :  1  1  1  1  1  1
--'C' :  1  1  1  1  1  1
--'D' :  1  1  1  1  1  1
--'E' :  1  1  1  1  1  1
--'F' :  1  1  1  1  1  1



--Matrix ReflexTransHuelle- Spezialfall Mat5

--      'A''B''C''D''E''F'

--'A' :  1  1  1  1  1  1
--'B' :  1  1  1  1  1  1
--'C' :  1  1  1  1  1  1
--'D' :  1  1  1  1  1  1
--'E' :  1  1  1  1  1  1
--'F' :  1  1  1  1  1  1  