-- Generisches Package das Funktionen auf Mengen bereitstellt.
-- Package Specification


-- Festlegung des generischen Typs Z
generic
   type Z is (<>); 

   -- Definieren des Aufbaus der Menge durch eine Liste
   package Mengen is
   type ListZ is array (Z) of Boolean; 


   -- Erstellt eine leere Menge.
   function NeueLeerMenge return ListZ; 

   -- Fgt ein neues Element in die Menge ein. 
   procedure Einfgen (E : Z; Ch : in out ListZ); 

   -- Lscht ein Element aus der Menge.
   procedure Loesche (E : Z; Ch : in out ListZ); 

   -- berprft ob ein bestimmtes Element in der Menge 
   -- vorhanden ist.
   function Vorhanden (E : Z; Ch : ListZ) return Boolean; 

   -- Prft ob eine Menge leer ist.
   function IstLeer (Ch : ListZ) return Boolean; 

   -- Bildet die Vereinigungsmenge zweier Mengen.
   function Vereinigung (Ch1, Ch2 : ListZ) return ListZ; 

   -- Bildet die Schnittmenge zweier Mengen.
   function Schnitt (Ch1, Ch2 : ListZ) return ListZ; 

end Mengen;